libstdc++: std::__basic_future< _Res > Class Template Reference

libstdc++

std::__basic_future< _Res > Class Template Reference
Concurrency » Futures

`#include <future>`

Inheritance diagram for std::__basic_future< _Res >:
[legend]

## Public Member Functions
| __basic_future (const __basic_future &)=delete
__basic_future & | operator= (const __basic_future &)=delete
bool | valid () const noexcept
void | wait () const
template<typename _Rep, typename _Period>
future_status | wait_for (const chrono::duration< _Rep, _Period > &__rel) const
template<typename _Clock, typename _Duration>
future_status | wait_until (const chrono::time_point< _Clock, _Duration > &__abs) const

## Protected Types
typedef __future_base::_Result< _Res > & | __result_type
typedef shared_ptr< _State_base > | __state_type

## Protected Member Functions
| __basic_future (const __state_type &__state)
| __basic_future (const shared_future< _Res > &) noexcept
| __basic_future (future< _Res > &&) noexcept
| __basic_future (shared_future< _Res > &&) noexcept
__result_type | _M_get_result () const
void | _M_swap (__basic_future &__that) noexcept

## Detailed Description

template<typename _Res>
class std::__basic_future< _Res >

Common implementation for future and shared_future.

Definition at line 704 of file future.

## Member Typedef Documentation

## ◆ __result_type

template<typename _Res>

typedef __future_base::_Result<_Res>& std::__basic_future< _Res >::__result_type
| protected

Definition at line 708 of file future.

## ◆ __state_type

template<typename _Res>

typedef shared_ptr<_State_base> std::__basic_future< _Res >::__state_type
| protected

Definition at line 707 of file future.

## Constructor & Destructor Documentation

## ◆ __basic_future() [1/2]

template<typename _Res>

std::__basic_future< _Res >::__basic_future | ( | const __state_type & | __state | ) |
| inlineexplicitprotected

Definition at line 763 of file future.

## ◆ __basic_future() [2/2]

template<typename _Res>

std::__basic_future< _Res >::__basic_future | ( |  | ) |
| inlineconstexprprotectednoexcept

Definition at line 781 of file future.

## Member Function Documentation

## ◆ _M_get_result()

template<typename _Res>

__result_type std::__basic_future< _Res >::_M_get_result | ( |  | ) | const
| inlineprotected

Wait for the state to be ready and rethrow any stored exception.

Definition at line 747 of file future.

Referenced by std::future< _Res >::get(), and std::shared_future< _Res >::get().

## ◆ _M_swap()

template<typename _Res>

void std::__basic_future< _Res >::_M_swap | ( | __basic_future< _Res > & | __that | ) |
| inlineprotectednoexcept

Definition at line 756 of file future.

## ◆ valid()

template<typename _Res>

bool std::__basic_future< _Res >::valid | ( |  | ) | const
| inlinenoexcept

Definition at line 719 of file future.

## ◆ wait()

template<typename _Res>

void std::__basic_future< _Res >::wait | ( |  | ) | const
| inline

Definition at line 722 of file future.

## ◆ wait_for()

template<typename _Res>
template<typename _Rep, typename _Period>

future_status std::__basic_future< _Res >::wait_for | ( | const chrono::duration< _Rep, _Period > & | __rel | ) | const
| inline

Definition at line 730 of file future.

## ◆ wait_until()

template<typename _Res>
template<typename _Clock, typename _Duration>

future_status std::__basic_future< _Res >::wait_until | ( | const chrono::time_point< _Clock, _Duration > & | __abs | ) | const
| inline

Definition at line 738 of file future.

The documentation for this class was generated from the following file:

- future